VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{86CF1D34-0C5F-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCT2.OCX"
Begin VB.Form RunExp 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Run Experiment"
   ClientHeight    =   4200
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   3975
   Icon            =   "RunExp.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4200
   ScaleWidth      =   3975
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton Command1 
      Cancel          =   -1  'True
      Caption         =   "Mouse"
      Height          =   255
      Left            =   3000
      TabIndex        =   12
      Top             =   480
      Width           =   855
   End
   Begin VB.CheckBox HideMouse 
      Caption         =   "Hide Mouse"
      Height          =   255
      Left            =   1680
      TabIndex        =   11
      Top             =   480
      Value           =   1  'Checked
      Width           =   1215
   End
   Begin MSComCtl2.UpDown UpDown1 
      Height          =   1815
      Left            =   3600
      TabIndex        =   10
      Top             =   840
      Width           =   255
      _ExtentX        =   450
      _ExtentY        =   3201
      _Version        =   393216
      Enabled         =   -1  'True
   End
   Begin VB.TextBox Subject 
      Height          =   285
      Left            =   1320
      TabIndex        =   9
      Top             =   120
      Width           =   2535
   End
   Begin VB.CommandButton AddComment 
      Caption         =   "Add Message"
      Height          =   375
      Left            =   1320
      TabIndex        =   7
      Top             =   2760
      Width           =   1215
   End
   Begin MSComDlg.CommonDialog CommonDialog2 
      Left            =   3360
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   1680
      Top             =   4200
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton btnRunExp 
      Caption         =   "Run"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   3720
      Width           =   3735
   End
   Begin VB.CommandButton SaveExp 
      Caption         =   "Save Experiment"
      Height          =   375
      Left            =   2040
      TabIndex        =   5
      Top             =   3240
      Width           =   1815
   End
   Begin VB.CommandButton LoadExp 
      Caption         =   "Open Experiment"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   3240
      Width           =   1815
   End
   Begin VB.CommandButton RemoveCluster 
      Caption         =   "Remove Event"
      Height          =   375
      Left            =   2640
      TabIndex        =   3
      Top             =   2760
      Width           =   1215
   End
   Begin VB.CommandButton AddCluster 
      Caption         =   "Add Cluster"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   2760
      Width           =   1095
   End
   Begin VB.ListBox clusters 
      Height          =   1815
      ItemData        =   "RunExp.frx":1042
      Left            =   120
      List            =   "RunExp.frx":1044
      TabIndex        =   0
      Top             =   840
      Width           =   3375
   End
   Begin VB.Label Label2 
      Caption         =   "Subject name:"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   120
      Width           =   1095
   End
   Begin VB.Label label1 
      Caption         =   "Clusters to run:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
End
Attribute VB_Name = "RunExp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub AddCluster_Click()
On Error GoTo fout
CommonDialog1.InitDir = BoxDir
CommonDialog1.FileName = ""
CommonDialog1.CancelError = True
CommonDialog1.Filter = "BoxTask Files (*.box)|*.box"
CommonDialog1.ShowOpen
clusters.AddItem CommonDialog1.FileName
Exit Sub

fout:
If Err = cdlCancel Then
Exit Sub
Else
bla = MsgBox("An unknown error occurred: code " & Err, vbCritical, "Error")
Resume Next
End If

'voeg een scrollbar toe als dat nodig is
Call ScrollBar

End Sub
Private Sub ScrollBar()
  Dim c As Long
   Dim rcText As RECT
   Dim newWidth As Long
   Dim itemWidth As Long
   Dim sysScrollWidth As Long
   

  'get the width of the system scrollbar
   sysScrollWidth = GetSystemMetrics(SM_CXVSCROLL)
   
  'loop through the list items, using DrawText
  'with DT_CALCRECT to determine the longest item.
   For c = 0 To clusters.ListCount - 1
   
      Call DrawText(RunExp.hdc, (clusters.List(c)), -1&, rcText, DT_CALCRECT)
      
     'calc the required width to display the
     'widest list item by adding the rect
     'width needed to display the item
     'with the width of the system scroll bar
      itemWidth = rcText.Right + sysScrollWidth
         
     'if this width is wider than a previous
     'value, save the longer width
      If itemWidth >= newWidth Then
         newWidth = itemWidth
      End If
      
   Next
   
  'add a horizontal scrollbar wide enough
  'to display the longest list item. If the
  'scrollbar is not needed, its not shown.
   Call SendMessage(clusters.hwnd, LB_SETHORIZONTALEXTENT, newWidth, ByVal 0&)

End Sub
Private Sub AddComment_Click()
comment = InputBox("Enter message", "Add message")
If comment <> "" Then clusters.AddItem "Message: " & comment
Call ScrollBar
End Sub

Private Sub btnRunExp_Click()
On Error GoTo fout

If clusters.ListCount = 0 Then Exit Sub

If Subject.Text = "" Then
    MsgBox "Please enter a subject name.", vbInformation, "Run Experiment"
    Subject.SetFocus
    Exit Sub
End If

'haal mousecursor weg
If HideMouse = 1 Then ShowCursor (False)

'controleer of output-filename al bestaat, zo ja vraag of er overschreven moet worden
If Dir(Subject.Text & ".bof") <> "" Then
    bla = MsgBox(Subject.Text & ".bof" & " already exists. Would you like to overwrite it?", vbYesNoCancel, "Save")
    If bla = vbYes Then GoTo Verder
    If bla = vbNo Then
        Subject.SetFocus
        Exit Sub
        End If
    If bla = vbCancel Then Exit Sub
End If

Verder:
'maak outputbestand gereed
Open Subject.Text & ".bof" For Output As #1
Print #1, Date, time, Subject.Text
Print #1, "Trial"; Chr(9); "Cluster"; Chr(9); "Total boxes"; Chr(9); "Total objects"; Chr(9); "Target"; Chr(9); "Total time"; Chr(9); "Total opened"; Chr(9); "Click order"; Chr(9); "Timed click order"; Chr(9); "Within Error"
Close

ClusterBoodschap = ""
'hier trialscreen aanroepen, daar hele lijst met message/clusters doorlopen.
HeelExperiment = True
TrialScreen.Show 1
Exit Sub

fout:

End Sub


Public Sub OpenFile(Bestand)
'On Error GoTo Fout

'maak array leeg
Erase AllBoxes


'haal textboxen enz weg
hoeveeltabs = BoxSettings.StartMessage.Count - 1
For aantal = 1 To hoeveeltabs
Unload BoxSettings.StartMessage(aantal)
Unload BoxSettings.TimeUpMessage(aantal)
Unload BoxSettings.EndMessage(aantal)
Unload BoxSettings.time(aantal)
Unload BoxSettings.CloseAfter(aantal)
Unload BoxSettings.ChangeColor(aantal)
Unload BoxSettings.ChangeForeColor(aantal)
Unload BoxSettings.ScreenSize(aantal)
Unload BoxSettings.TargetNumberText(aantal)
Unload BoxSettings.TargetIcon(aantal)
Next aantal

Open Bestand For Input As #1
'haal eruit hoeveel trials er in het cluster zitten
Input #1, getal
aantaltrials = Val(getal)
'voeg genoeg nieuwe tabs in
For aantal = 1 To aantaltrials - 1
'plaats de controls op de nieuwe tab
Load BoxSettings.StartMessage(aantal)
Load BoxSettings.TimeUpMessage(aantal)
Load BoxSettings.EndMessage(aantal)
Load BoxSettings.time(aantal)
Load BoxSettings.CloseAfter(aantal)
Load BoxSettings.ChangeColor(aantal)
Load BoxSettings.ChangeForeColor(aantal)
Load BoxSettings.ScreenSize(aantal)
Load BoxSettings.TargetNumberText(aantal)
Load BoxSettings.TargetIcon(aantal)
Next aantal
'''''''''''''dit stuk wordt geloopt voor elke trial
For trialtab = 0 To aantaltrials - 1

'haal eerst time, boodschap bij timeout en targetnummer en startmessage en endmessageuit  enz enz file, en zet target
Input #1, temp1
Input #1, temp2
Input #1, temp3
Input #1, temp4
Input #1, temp5
Input #1, temp6
Input #1, temp7
Input #1, temp8
Input #1, temp9
BoxSettings.time(trialtab).Text = temp1
BoxSettings.TimeUpMessage(trialtab).Text = temp2
BoxSettings.TargetNumberText(trialtab).Caption = temp3
BoxSettings.StartMessage(trialtab).Text = temp4
BoxSettings.EndMessage(trialtab).Text = temp5
BoxSettings.CloseAfter(trialtab).Text = temp6
BoxSettings.ChangeColor(trialtab).BackColor = temp7
BoxSettings.ChangeForeColor(trialtab).BackColor = temp8
BoxSettings.ScreenSize(trialtab).Text = temp9

'kijken hoeveel boxes er zijn
Input #1, getal
aantalboxes = Val(getal)
'bij inputwaarde "leeg" komt er eenlege box, en anders wordt de inhoud van de box weergegeven.

For aantalkeer = 1 To aantalboxes

Input #1, temp10
Input #1, temp11
Input #1, temp12
Input #1, temp13
Input #1, temp14
Input #1, temp15

AllBoxes(trialtab, aantalkeer).Doos = temp10
AllBoxes(trialtab, aantalkeer).LeegIcon = temp11
AllBoxes(trialtab, aantalkeer).Inhoud = temp12
AllBoxes(trialtab, aantalkeer).Leeg = temp13
AllBoxes(trialtab, aantalkeer).Left = BoxBreedteOpen(Val(temp14))
AllBoxes(trialtab, aantalkeer).Top = BoxHoogteOpen(Val(temp15))

Next aantalkeer
Next trialtab
'''''''''''''''''' einde loop


Close #1

'Zet de waarde van prevFilename
prevFilename = Bestand
prevFileTitle = Bestand

Exit Sub

fout:
If Err = cdlCancel Then
Exit Sub
Else
bla = MsgBox("An unknown error occurred: code " & Err, vbCritical, "Error")
Resume Next
End If
End Sub




Private Sub clusters_Click()
Call ScrollBar
ShowCursor True
End Sub

Private Sub Command1_Click()

ShowCursor True
End Sub




Private Sub Form_Unload(cancel As Integer)
BoxSettings.Show
End Sub

Private Sub LoadExp_Click()
On Error GoTo fout
CommonDialog1.InitDir = BoxDir
CommonDialog1.FileName = ""
CommonDialog1.CancelError = True
CommonDialog1.Filter = "BoxTask Experiment Files (*.bex)|*.bex"
CommonDialog1.ShowOpen


Open CommonDialog1.FileName For Input As #1
Do
Input #1, bla
clusters.AddItem bla
Loop Until EOF(1)
Close #1
RunExp.Caption = "Run Experiment - " & CommonDialog1.FileTitle
Exit Sub

fout:
If Err = cdlCancel Then
Exit Sub
Else
bla = MsgBox("An unknown error occurred: code " & Err, vbCritical, "Error")
Resume Next
End If
End Sub

Private Sub RemoveCluster_Click()
If clusters.ListIndex > -1 Then
clusters.RemoveItem clusters.ListIndex
End If
End Sub

Private Sub SaveExp_Click()
On Error GoTo fout
CommonDialog1.InitDir = BoxDir
CommonDialog1.FileName = ""
CommonDialog1.CancelError = True
CommonDialog1.Filter = "BoxTask Experiment Files (*.bex)|*.bex"
Terug:
CommonDialog1.ShowSave

'controleer of filename al bestaat, zo ja vraag of er overschreven moet worden
If Dir(CommonDialog1.FileName) <> "" Then
    bla = MsgBox(CommonDialog1.FileName & " already exists. Would you like to overwrite it?", vbYesNoCancel, "Save")
    If bla = vbYes Then GoTo Verder
    If bla = vbNo Then GoTo Terug
    If bla = vbCancel Then Exit Sub
End If
Verder:
Open CommonDialog1.FileName For Output As #1
For regel = 0 To clusters.ListCount - 1
Write #1, clusters.List(regel)
Next regel
Close #1
RunExp.Caption = "Run Experiment - " & CommonDialog1.FileTitle
Exit Sub

fout:
If Err = cdlCancel Then
Exit Sub
Else
bla = MsgBox("An unknown error occurred: code " & Err, vbCritical, "Error")
Resume Next
End If
End Sub


Private Sub UpDown1_DownClick()
If clusters.ListIndex > -1 And clusters.ListIndex < clusters.ListCount - 1 Then
nummer = clusters.ListIndex + 1
bla = clusters.List(clusters.ListIndex)
clusters.RemoveItem (clusters.ListIndex)
clusters.AddItem bla, nummer
clusters.ListIndex = nummer
End If
End Sub

Private Sub UpDown1_UpClick()
If clusters.ListIndex > 0 Then
nummer = clusters.ListIndex - 1
bla = clusters.List(clusters.ListIndex)
clusters.RemoveItem (clusters.ListIndex)
clusters.AddItem bla, nummer
clusters.ListIndex = nummer
End If
End Sub
